--
-- siloSell
-- 
-- 
--
-- upsideDown 16.12.2013

siloSell = {};
addModEventListener(siloSell);
function siloSell.prerequisitesPresent(specializations)
    return true;
end;

function siloSell:loadMap(name)
	--siloSell.transportFee = 0.2;-- 0.2 means 20% fee of best price
	--g_currentMission.missionStats.difficulty
	--siloSell.transportFee = 0.05 + .05*g_currentMission.missionStats.difficulty; --makes 10%,15%,20% for easy, medium, heavy difficulty
	siloSell.currentFillType = Fillable.FILLTYPE_WHEAT;
	siloSell.transportFee = 1000*g_currentMission.missionStats.difficulty; 
	siloSell.truckLoad = 45000;
	siloSell.clientRequest = false;
	siloSell.clientFillType = Fillable.FILLTYPE_UNKNOWN;
end;

function siloSell:deleteMap()
end


function siloSell:mouseEvent(posX, posY, isDown, isUp, button)
end;

function siloSell:keyEvent(unicode, sym, modifier, isDown)
end;


function siloSell:update(dt)
	if g_currentMission:getIsClient() then
		if g_gui.currentGui == nil then
			if g_currentMission:getIsServer() or g_currentMission.isMasterUser then
				if g_currentMission.controlledVehicle == nil then
					if not InputBinding.isPressed(InputBinding.siloVerkauf_mod) then
						g_currentMission:addHelpButtonText(g_i18n:getText("siloVerkauf3"), InputBinding.siloVerkauf_mod);
					end;
					if InputBinding.isPressed(InputBinding.siloVerkauf_mod) or siloSell.clientRequest then
						if siloSell.currentFillType ~= Fillable.FILLTYPE_UNKNOWN and InputBinding.isPressed(InputBinding.siloVerkauf_mod) then
							g_currentMission:setFillTypeOverlayFillType(siloSell.currentFillType);
						end;
						if InputBinding.isPressed(InputBinding.siloVerkauf_mod) then
							g_currentMission:addHelpButtonText(g_i18n:getText("siloVerkauf2"), InputBinding.siloVerkauf_2);
						end;
						--self.missionStats.farmSiloAmounts[fillType] = amount
						
						if g_currentMission.missionStats.farmSiloAmounts[siloSell.currentFillType] == 0 then
							siloSell.currentFillType = Fillable.FILLTYPE_UNKNOWN;
						end;
						
						if InputBinding.hasEvent(InputBinding.siloVerkauf_2) then
							local cnt = 0;
							
							siloSell.currentFillType = siloSell.currentFillType + 1;
							if siloSell.currentFillType > 64 then
								siloSell.currentFillType = 1;
							end;
							
							while Utils.getNoNil(g_currentMission.missionStats.farmSiloAmounts[siloSell.currentFillType],0) == 0 do
								siloSell.currentFillType = siloSell.currentFillType + 1;
								if siloSell.currentFillType > 64 then
									siloSell.currentFillType = 1;
								end;
								cnt = cnt+1;							
								if cnt > 65 then --silos are all empty
									siloSell.currentFillType = Fillable.FILLTYPE_UNKNOWN;
									break;
								end;
							end;					
						end;
					
						if siloSell.currentFillType ~= Fillable.FILLTYPE_UNKNOWN or (siloSell.clientRequest and siloSell.clientFillType ~= Fillable.FILLTYPE_UNKNOWN) then
							if InputBinding.isPressed(InputBinding.siloVerkauf_mod) then
								g_currentMission:addHelpButtonText(g_i18n:getText("siloVerkauf"), InputBinding.siloVerkauf_1);
							end;
							local fillType = siloSell.currentFillType;--Fillable.FILLTYPE_WHEAT;
							if siloSell.clientRequest or InputBinding.hasEvent(InputBinding.siloVerkauf_1) then
								if siloSell.clientRequest then
									fillType = siloSell.clientFillType;
									siloSell.clientRequest = false;
								end;
								local Amount = g_currentMission:getSiloAmount(fillType);							
								
								-- local sellSpeed = 4.0;
								-- if InputBinding.isPressed(InputBinding.siloVerkauf_fast) then	
									-- sellSpeed = sellSpeed*10;
								-- end;
								--local delta = math.min(dt*sellSpeed,Amount);
								
								local delta = math.min(siloSell.truckLoad,Amount);
								
								local desc = Fillable.fillTypeIndexToDesc[fillType];
								desc.totalAmount = desc.totalAmount - delta;
					
								local priceFactor = 0;
								for _,tip in pairs(g_currentMission.tipTriggers) do
									local testFactor = Utils.getNoNil(tip.priceMultipliers[fillType],0);
									
									local greatDemand = g_currentMission.economyManager:getCurrentGreatDemand(tip.stationName, fillType);
									local greatDemandMultiplier = 1;
									if greatDemand ~= nil then
										testFactor = testFactor*greatDemand.demandMultiplier;
									end;
									priceFactor = math.max(priceFactor,testFactor);							
								end;
								
								local difficultyMultiplier = math.max(2 * (3 - g_currentMission.missionStats.difficulty), 1);
								local money = Fillable.fillTypeIndexToDesc[fillType].pricePerLiter * priceFactor * difficultyMultiplier * delta;
								if g_currentMission:getIsServer() then
									g_currentMission:setSiloAmount(fillType,Amount-delta);
									g_currentMission:addSharedMoney(money, "harvestIncome");
									g_currentMission:addSharedMoney(siloSell.transportFee, "wagePayment");						
								else
									g_client:getServerConnection():sendEvent(siloSellEvent:new(fillType));
								end;
							end;
						end;
					end;	
				end;
			end;
		end;
	end
end


function siloSell:draw()   
end;


siloSellEvent = {};
siloSellEvent_mt = Class(siloSellEvent, Event);

InitEventClass(siloSellEvent, "siloSellEvent");

function siloSellEvent:emptyNew()
    local self = Event:new(siloSellEvent_mt);
    return self;
end;

function siloSellEvent:new(fillType,fillLevel,money)
    local self = siloSellEvent:emptyNew()
    self.fillType = fillType;
    return self;
end;

function siloSellEvent:readStream(streamId, connection)   
    self.fillType = streamReadInt8(streamId);
    self:run(connection);
end;

function siloSellEvent:writeStream(streamId, connection)    
    streamWriteInt8(streamId, self.fillType);
end;

function siloSellEvent:run(connection)
	siloSell.clientFillType = self.fillType;
	siloSell.clientRequest = true;
end;